<template>
    <div class="hero bg-cover min-h-screen min-w-screen" :style="{ backgroundImage: `url(${heroBackgroundImage})` }">
        <div class="hero-overlay bg-opacity-60"></div>
        <div class="glass hero-content text-center text-neutral-content m-3 rounded-lg">
            <form class="max-w-md" @submit.prevent="login">
                <h1 class="mb-5 text-5xl font-bold">LogIn</h1>
                <div class="mb-5">
                    <div class="form-control">
                        <label class="label">
                            <span class="label-text" for="email">Email</span>
                        </label>
                        <input type="email" required v-model="email" name="mail" placeholder="mario@rossi.it" class="input input-bordered" />
                    </div>
                    <div class="form-control">
                        <label class="label">
                            <span class="label-text" for="password">Password</span>
                        </label>
                        <input type="password" required v-model="password" name="mail" placeholder="········" class="input input-bordered" />
                    </div>
                    <button class="btn btn-primary mt-5">Login User</button>
                </div>
                <!-- Error Alert -->
                <Alert v-if="showError" type="error" title="Error" :body="errorText" />
            </form>
        </div>
    </div>
</template>

<script>
    import store from "@/store"
    import Alert from "@/components/Alert.vue"
    import heroImage from '@/assets/bg_2.jpg'
    
    export default {
        components: {
            Alert
        },
        data: () => {
            return {
                username: "",
                password: "",
                showError: false,
                errorText: "",
                heroBackgroundImage: heroImage,
            }
        },
        methods: {
            login() {
                var self = this;
                self.$axios.post('/user/login', {
                    email: self.email,
                    password: self.password
                }).then(async function (response) {
                    // autentico
                    store.setUserToken(response.data.token)
                    // reidirizzo
                    const redirectPath = self.$route.query.redirect || "/";
                    await self.$router.push({path: redirectPath})
                    self.$router.go(0)
                }).catch(function (error) {
                    self.errorText = error.response.data.message || JSON.stringify(error)
                    self.showError = true
                });
            }
        },
    }
</script>